package drew;

import java.awt.*;
import javax.swing.*;
import math.Vec;

public class ColorDisplay extends JPanel
  implements java.io.Serializable
{
  
  static final long serialVersionUID = 6173314909403425932L;
  
  Color color = new Color(0,0,0);

  public Color getColor() { return color; }
  public void setColor(Color color) 
  { 
    this.color = color;
    repaint();
  }

  public void paint(Graphics g)
  {

    g.setColor(color);
    g.fillRect(0, 0, getWidth(), getHeight());

    g.setColor(Color.black);
    g.drawRect(0, 0, getWidth()-1, getHeight()-1);
  }


  public ColorDisplay()
  {
    super();
    setSize(100,100);
  }

  Vec v = new Vec(3);

  public Vec getColorVec()
  {
    v.set(0, (double) color.getRed());
    v.set(1, (double) color.getGreen());
    v.set(2, (double) color.getBlue());
    return v;
  }

  public void setColorVec(Vec v)
  {
    if (v.ref(0) < 0)
      v.set(0, 0);
    else if (v.ref(0) > 255)
      v.set(0, 255);

    if (v.ref(1) < 0)
      v.set(1, 0);
    else if (v.ref(1) > 255)
      v.set(1, 255);

    if (v.ref(2) < 0)
      v.set(2, 0);
    else if (v.ref(2) > 255)
      v.set(2, 255);

    color = new Color((int) v.ref(0), (int) v.ref(1), (int) v.ref(2));
    repaint();
  }


}
