package drew;

import java.beans.*;

public class Counter implements java.io.Serializable
{
  static final long serialVersionUID = 3171100660842140284L;

  int count = 0;

  public int getCount() { return count; }
  private void setCount(int count) 
  { 
    System.out.println("setCount");
    int oldValue = this.count;
    this.count = count; 
    changes.firePropertyChange("count", new Integer(oldValue), new Integer(count));
  }

  long startTime;
  long rateTicks = 0;

  public void tick()
  {
    setCount(getCount() + 1);
    long timeNow = System.currentTimeMillis();

    rateTicks++;
    if ( (timeNow - startTime) > rateUpdateInterval )
      {
	double r  = ( (double)rateTicks / (timeNow - startTime) * 1000.0);
	r = ((double)((int) (r * 100.0)))/100.0;
	setRate(r);

	rateTicks = 0;
	startTime = timeNow;
      }
  }
  
  double rate;
  public double getRate() { return rate; }
  private void setRate(double rate)
  {
    double oldValue = this.rate;
    this.rate = rate;
    changes.firePropertyChange("rate", new Double(oldValue), new Double(rate));
  }
  
  int rateUpdateInterval = 1000;
  public int getRateUpdateInterval() { return rateUpdateInterval; }
  public void setRateUpdateInterval(int i)
  {
    this.rateUpdateInterval = i;
  }


  private PropertyChangeSupport changes = new PropertyChangeSupport(this);

  public void addPropertyChangeListener(PropertyChangeListener l) 
  {
    changes.addPropertyChangeListener(l);
  }

  public void removePropertyChangeListener(PropertyChangeListener l) 
  {
    changes.removePropertyChangeListener(l);
  }

}
