package drew;

import java.beans.*;
import math.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;

public class MatrixDisplay extends JTable
  implements java.io.Serializable
{
  static final long serialVersionUID = 308589313991159291L;

  Matrix value = new Matrix(5,5);

  TableModel tableModel;

  public MatrixDisplay()
  {
    setValue(value);
  }

  public void setValue(Matrix value)
  {
    this.value = value;

    tableModel = new MyTableModel();
    setModel(tableModel);
    setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

    TableColumnModel tcm = getColumnModel();
    
    for (int i = 0; i < tcm.getColumnCount(); i++)
      {
	TableColumn column = tcm.getColumn(i);
	//column.setMinWidth(60);
      }
    int w = getIntercellSpacing().width;
    int h = getIntercellSpacing().height;

    int scrollWidth = value.numColumns()*tcm.getColumn(0).getWidth()+w*value.numColumns();
    int scrollHeight = value.numRows()*getRowHeight()+h*value.numRows();

    int maxWidth = 4*(tcm.getColumn(0).getWidth() + w);
    int maxHeight = 4*(getRowHeight() + h);
    if (scrollWidth > maxWidth)
      scrollWidth = maxWidth;
    if (scrollHeight > maxHeight)
      scrollHeight = maxHeight;


    setPreferredScrollableViewportSize(new Dimension(scrollWidth, scrollHeight));


  }

  public Matrix getValue() { return value; }

  public void addPropertyChangeListener(PropertyChangeListener l) 
  {
    changes.add(l);
  }
  
  public void removePropertyChangeListener(PropertyChangeListener l) 
  {
    changes.remove(l);
  }

  private drew.util.EventListenerList changes = new drew.util.EventListenerList();

  

  class MyTableModel extends AbstractTableModel 
  {
    public String getColumnName(int col) { 
      return Integer.toString(col);
    }
    public int getRowCount() { return value.numRows(); }
    public int getColumnCount() { return value.numColumns(); }
    public Object getValueAt(int row, int col) {
      //return new Double(value.ref(row,col));
      return drew.util.Format.formatDouble(value.ref(row,col),4);
    }
    public boolean isCellEditable(int row, int col) { return true; }
    public void setValueAt(Object scalar, int row, int col) 
      {
	Double newDoubleValue = Double.valueOf((String)scalar);
	((Matrix)value).set(row,col,newDoubleValue.doubleValue());
	fireTableCellUpdated(row, col);
	//System.out.println("setValueAt " + value);
	changes.firePropertyChange(this, "value", value, value);
      }
  }


}


