package drew;

import java.text.*;

public class TestNumberFormat
{
  static NumberFormat nf = NumberFormat.getInstance();


  String format(double d)
  {
    DecimalFormat df = (DecimalFormat) nf;
    df.setGroupingUsed(false);

    double m = Math.abs(d);

    String s;
    if ((m >= 1.0E-4) && (m < 10E5))
      {
	// worst case:  -10000.1234 is length 12
	// no sci notation
	df.applyPattern("#.####");
	s = df.format(d);
      }
    else
      {
	// worst case: -x.xxxxE-xxx is length 12
	df.applyPattern("#.####E0");
	s = df.format(d);
      }
    
    while (s.length() < 12)  
      s = " " + s;
    
    return s;
  }

  String format2(double d)
  {
    String s = Double.toString(d);


    return s;
  }



  public static void main(String args[])
  {
    TestNumberFormat tnf = new TestNumberFormat();
    System.out.println(tnf.format(100));

    System.out.println(tnf.format(10000000000.0));
    System.out.println(tnf.format(0.1));
    System.out.println(tnf.format(0.0000000000012345));


    System.out.println(tnf.format(1.0E8));
    System.out.println(tnf.format(1.0E-9));
    


    System.out.println("\n");

    System.out.println(tnf.format(100000000000.0));
    System.out.println(tnf.format(-100.24568989289283928392839238));
    System.out.println(tnf.format(0.00000000000024568989289283928392839238));
    System.out.println(tnf.format( 1000000.0));
    System.out.println(tnf.format(-100000.123456));
    System.out.println(tnf.format(-1000000.123456));

    System.out.println(tnf.format(0.001));

    System.out.println(tnf.format(0.0001));

    System.out.println(tnf.format(0.00001));

    System.out.println(tnf.format(0.000001));
    
   




  }
}
