package drew;

import java.beans.*;
import math.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;

public class VecDisplay extends JTable
  implements java.io.Serializable
{
  static final long serialVersionUID = 286190958069077180L;
  Vec value = new Vec(1);

  TableModel tableModel;

  public VecDisplay()
  {
    setValue(value);
  }

  public void setValue(Vec value)
  {
    this.value = value;

    tableModel = new MyTableModel();
    setModel(tableModel);
    setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

    //System.out.println("value.size() == " + value.size());


    TableColumnModel tcm = getColumnModel();
    
    for (int i = 0; i < tcm.getColumnCount(); i++)
      {
	TableColumn column = tcm.getColumn(i);
	//column.setMinWidth(40);
	//column.setWidth(100);
      }
    int w = getIntercellSpacing().width;

    int scrollWidth = value.size()*tcm.getColumn(0).getWidth()+w*value.size();
    
    int scrollHeight = 17;

    int maxWidth = 4*(tcm.getColumn(0).getWidth() + w);

    if (scrollWidth > maxWidth)
      scrollWidth = maxWidth;

    setPreferredScrollableViewportSize(new Dimension(scrollWidth, scrollHeight));

    //System.out.println("setValue " + value);
    //invalidate();
  }

  public Vec getValue() { return value; }
  public void addPropertyChangeListener(PropertyChangeListener l) 
  {
    changes.add(l);
  }
  
  public void removePropertyChangeListener(PropertyChangeListener l) 
  {
    changes.remove(l);
  }

  private drew.util.EventListenerList changes = new drew.util.EventListenerList();


  
  

  class MyTableModel extends AbstractTableModel 
  {
    public String getColumnName(int col) { 
      return Integer.toString(col);
    }
    public int getRowCount() { return 1; }
    public int getColumnCount() { return value.size(); }
    public Object getValueAt(int row, int col) {
      return drew.util.Format.formatDouble(value.ref(col),4);
      //new Double(value.ref(col)); 
    }
    public boolean isCellEditable(int row, int col) { return true; }
    public void setValueAt(Object scalar, int row, int col) 
      {
	Double newDoubleValue = Double.valueOf((String)scalar);
	((Vec)value).set(col,newDoubleValue.doubleValue());
	fireTableCellUpdated(row, col);
	//System.out.println("setValueAt " + value);
	changes.firePropertyChange(this, "value", value, value);
      }
  }

}


