package drew.figure;

import java.awt.*;

public abstract class Figure implements java.io.Serializable
{
  static final long serialVersionUID = 2617660373552685548L;

  public abstract void paint(Graphics g);
  public void register(FigureAxes fa) {enclosingAxes = fa; }

  protected FigureAxes enclosingAxes;

  protected boolean toldAxes;

  protected double minX, maxX, minY, maxY;
  protected Rectangle graphRect = new Rectangle();

  public void setAxes(double minX, double maxX, double minY, double maxY, Rectangle graphRect)
  {
    /*
    boolean changed = false;
    changed = (this.minX != minX) || (this.maxX != maxX) ||
      (this.minY != minY) || (this.maxY != maxY) || (!this.graphRect.equals(graphRect));

    System.out.println(graphRect.width + " " + this.graphRect.width);
    */

    this.minX = minX;
    this.maxX = maxX;
    this.minY = minY;
    this.maxY = maxY;
    this.graphRect = graphRect;

    /*
    System.out.println("setAxes " + changed);
    //return changed;
    return true;
    */
  }


  void transform(double x, double y, Point p)
  {
    p.x = (int) ((x - minX)/(maxX-minX)*graphRect.width);
    p.y = (int) (graphRect.height - (y - minY)/(maxY-minY)*graphRect.height);

  }

  protected Color foreground = Color.black;
  public Color getForeground() { return foreground; }
  public void setForeground(Color foreground)
  {
    this.foreground = foreground;
    if (enclosingAxes != null)
      enclosingAxes.repaint();
  }
  
  boolean live = true;
  public boolean getLive() { return live; }
  public void setLive(boolean live) { this.live = live; }

}
