package drew.figure;

import math.*;
import java.awt.image.*;

public class MatrixImageFigure extends MemoryImageFigure
{
  int[] pixelArray;
  double min = 0, max = 1.0;

  public void setMatrix(Matrix m)
  {
    setWidth(m.numColumns());
    setHeight(m.numRows());

    if (pixelArray == null)
      pixelArray = new int[m.numColumns()*m.numRows()];

    int n = 0;
    for (int i = 0; i < m.numRows(); i++)
      for (int j = 0; j < m.numColumns(); j++)
	pixelArray[n++] = scale(m.ref(i,j));

    setPixels(pixelArray, colorModel);
  }

  public void setMatrix(double[] m)
  {
    if (pixelArray == null)
      pixelArray = new int[m.length];

    int n = 0;
    for (int i = 0; i < m.length; i++)
      pixelArray[n++] = scale(m[i]);

    setPixels(pixelArray, colorModel);
  }


  protected int scale(double d)
  {
    return (int) (255.0 * ((d - min)/(max - min) + min));
  }

  public double getMin() { return min; }
  public void setMin(double d) { min = d; }

  public double getMax() { return max; }
  public void setMax(double d) { max = d; }

  transient ColorModel colorModel = new DirectColorModel(24, 255, 255, 255);

}


