package drew.figure;

import math.*;

public class StripChart extends Plot implements java.io.Serializable
{

  double[] domain;
  public double[] getDomain() { return domain; }
  public void setDomain(double[] a) { domain = a; }
  
  double[] range;
  public double[] getRange() { return range; }
  public void setRange(double[] a) { range = a; }
  
  

  boolean autoScaleRange = false;
  public boolean getAutoScaleRange() { return autoScaleRange; }
  public void setAutoScaleRange(boolean b) { autoScaleRange = b; }


  boolean autoScaleDomain = false;
  public boolean getAutoScaleDomain() { return autoScaleDomain; }
  public void setAutoScaleDomain(boolean b) { autoScaleDomain = b; }
  

  public void setNext(double x)
  {
    if (range == null)
      range = new double[0];

    if (maxX == 0) return;
    

    if (range.length > (int) maxX)
      {
	double[] newRange = new double[(int) maxX];
	for (int i = 0; i < (int) maxX; i++)
	  newRange[i] = range[i];
	
	range = newRange;
	defaultDomain();
      }
    else
      if (range.length < (int) maxX)
      {
	double[] newRange = new double[range.length+1];
	for (int i = 0; i < range.length; i++)
	  newRange[i] = range[i];
	range = newRange;
	defaultDomain();
      }
    else
      {
	for (int i = 0; i < range.length-1; i++)
	  range[i] = range[i+1];
      }

    range[range.length - 1] = x;

    if (autoScaleRange)
      {
	double min = Double.POSITIVE_INFINITY;
	double max = Double.NEGATIVE_INFINITY;
	for (int i = 0; i < range.length; i++)
	  {
	    if (range[i] > max)
	      max = range[i];
	    if (range[i] < min)
	      min = range[i];
	  }

	if (enclosingAxes != null)
	  {
	    enclosingAxes.setMinY(min);
	    enclosingAxes.setMaxY(max);
	  }
      }
  }

  
  public int domainSize()
  {
    if (domain == null)
      return 0;
    else
      return domain.length;
  }
  
  public double domainRef(int i)
  {
    return domain[i];
  }
  
  
  public int rangeSize()
  {
    if (range == null)
      return 0;
    else return range.length;
  }

  public double rangeRef(int i)
  {
    return range[i];
  }

  
  public void defaultDomain()
  {
    domain = new double[rangeSize()];
    for (int i = 0; i < rangeSize(); i++)
      domain[i] = (double) i;
    if (autoScaleDomain && (enclosingAxes != null))
      {
	enclosingAxes.setMinX(0);
	enclosingAxes.setMaxX((double)domain.length);
	
      }
  }





}
