package drew.util;

import java.util.Vector;

public class VectorOps
{

  public static Vector reverse(Vector v)
  {
    Vector out = new Vector();
    for (int i = 0; i < v.size(); i++)
      out.insertElementAt(v.elementAt(i), 0);
    return out;
  }

  public static Vector union(Vector a, Vector b)
  {
    Vector out = (Vector) a.clone();
    for (int i = 0; i < b.size(); i++)
      if (!a.contains(b.elementAt(i)))
	out.addElement(b.elementAt(i));
    return out;
  }

  public static Vector addAndReplace(Vector a, Object o)
  {
    Vector out = (Vector) a.clone();
    if (!out.contains(o))
      out.addElement(o);
    return out;
  }

  public static Vector setDifference(Vector a, Vector b)
  {
    Vector out = new Vector();
    for (int i = 0; i < a.size(); i++)
      if (!b.contains(a.elementAt(i)))
	out.addElement(a.elementAt(i));
    return out;
  }

  public static Vector intersect(Vector a, Vector b)
  {
    Vector out = new Vector();
    for (int i = 0; i < a.size(); i++)
      if (b.contains(a.elementAt(i)))
	out.addElement(a.elementAt(i));
    return out;
  }

  public static boolean subset(Vector a, Vector b)
  {
    boolean out = true;
    for (int i = 0; i < a.size(); i++)
      out = out && b.contains(a.elementAt(i));
    return out;
  }

  public static Vector order(Vector a, Vector ordered)
  {
    Object[] bins = new Object[ordered.size()];
    for (int i = 0; i < a.size(); i++)
      bins[ordered.indexOf(a.elementAt(i))] = a.elementAt(i);
    
    Vector out = new Vector();
    for (int i = 0; i < bins.length; i++)
      if (bins[i] != null)
	out.addElement(bins[i]);
    return out;
  }

}
